#!/bin/sh
# sievecp.sh,v 1.1 2007-03-07 10:30:23 moriai Exp

NILFSDIR=`df -t nilfs "$1" 2>/dev/null | awk 'NR == 2 { sub("/[^/]*$", "", $6); print $6 }'`
if [ -z "$NILFSDIR" ]; then
	kdialog --sorry "$1: Not in NILFS."
	exit 0
fi

NAVIFILE="$NILFSDIR/idx/navi-$$.html"
INDEXFILE="$NILFSDIR/idx/index-$$.html"

cp /dev/null "$NAVIFILE"
cp /dev/null "$INDEXFILE"
chmod 600 "$NAVIFILE" "$INDEXFILE"

BASENAME=`echo "$1" | sed 's!'"$NILFSDIR"'/[^/]*/!!'` 
 
du -a "$NILFSDIR"/*/"$BASENAME" \
	| awk '$1 != "0" { split($2, a, "/"); print a[3] }' \
	| seekcp --select=- --html=date-sketch "$NILFSDIR"/idx/cplist.all \
		>>"$NAVIFILE"

cat <<EOF >>"$INDEXFILE"
<HTML>
<HEAD>
    <TITLE>$BASENAME snapshots</TITLE>
</HEAD>
<FRAMESET COLS="35%,65%">
    <FRAME SRC="$NAVIFILE" NAME="Navi">
    <FRAME SRC="" NAME="Content">
<BODY>
</BODY>
</FRAMESET>
</HTML>
EOF

kfmclient newTab file://"$INDEXFILE"

sleep 10
rm -f "$NAVIFILE" "$INDEXFILE"

exit 0
