#!/bin/sh
#
# updatecp - checkpoint list updater
#
# Copyright (C) 2006 Nippon Telegraph and Telephone Corporation.
# This file is part of NILFS and is licensed under the GPL.
#
# updatecp.sh,v 1.6 2007-05-15 04:06:16 moriai Exp
#
# Written by Satoshi Moriai <moriai@osrg.net>
#

PATH=/usr/bin:/bin:/sbin:/usr/sbin; export PATH

OPTS=
while [ $# -gt 0 ]; do
	case "$1" in
	-*)	OPTS="$OPTS $1" ;;
	*)	break ;;
	esac
	shift
done

case "$#" in
2)	;;
*)	echo "Usage: updatecp [seekcp-opts] nilfsdir interval"
	exit 1
	;;
esac

NILFSDIR="$1"
INTERVAL="$2"
NILFSCUR="$NILFSDIR"/cur
NILFSIDX="$NILFSDIR"/idx

[ -d "$NILFSCUR" ] || { echo "$NILFSDIR isn't a mount point." 1>&2; exit 1; }

NILFSDEV=`awk '$2 == "'"$NILFSCUR"'" {print $1}' /proc/mounts`

[ -n "$NILFSDEV" ] || { echo "$NILFSDIR isn't a mount point." 1>&2; exit 1; }

cd "$NILFSIDX" || { echo "$NILFSIDX doesn't exist." 1>&2 ; exit 1; }

cat <<"EOF" >"$NILFSIDX/index.html" || exit 1
<HTML>
<HEAD>
    <TITLE>NILFS snapshot list</TITLE>
</HEAD>
<FRAMESET COLS="35%,65%">
    <FRAME SRC="navi.html" NAME="Navi">
    <FRAME SRC="" NAME="Content">
<BODY>
</BODY>
</FRAMESET>
</HTML>
EOF

rm -f "$NILFSIDX/sketch.jpg"; ln -s ../cur/.sketch "$NILFSIDX/sketch.jpg"

echo $$ >"/var/run/nilfs/`echo $NILFSDIR | sed -e 's!^/*!!' -e 's!/*$!!' -e 's!/!_!g'`.pid"

while [ -d "$NILFSCUR" ]; do
	if seekcp -l "$NILFSDEV" >"$NILFSIDX"/cplist.all; then
		eval seekcp "$OPTS" "$NILFSIDX"/cplist.all >"$NILFSIDX"/navi-new.html
		mv "$NILFSIDX"/navi-new.html "$NILFSIDX"/navi.html
		sleep $INTERVAL
	else
		echo "updatecp: Can't update checkpoint list." >&2
		exit 1
	fi
done

exit 0
